<template>
  <form @submit.prevent="submitForm" method="post">
    <el-dialog
      title="เพิ่มพื้นที่ดำเนินงาน"
      v-model="openDialog"
      width="350px"
      :before-close="handleClose"
    >
      <div class="mb-2 grid">
        <p>พื้นที่ดำเนินงาน</p>
        <textarea
          :class="`${errors.address ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.address"
          placeholder="พื้นที่ดำเนินงาน"
        ></textarea>
        <small class="text-red-500 font-bold">{{ errors?.address }} </small>
      </div>
      <div class="mb-2 grid">
        <p>ละติจูด</p>
        <input
          :class="`${errors.lat ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.lat"
          placeholder="ละติจูด"
        />
        <small class="text-red-500 font-bold">{{ errors?.lat }} </small>
      </div>
      <div class="mb-2 grid">
        <p>ลองจิจูด</p>
        <input
          :class="`${errors.long ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.long"
          placeholder="ลองจิจูด"
        />
        <small class="text-red-500 font-bold">{{ errors?.long }} </small>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <button
            @click="handleClose"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-red-600
              to-red-400
              rounded-md
              text-white
              shadow-md
              mr-2
              focus:outline-none
            "
            type="button"
          >
            ยกเลิก
          </button>
          <button
            type="submit"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-600
              to-green-400
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
          >
            เพิ่ม
          </button>
        </span>
      </template>
    </el-dialog>
  </form>
</template>

<script>
import { Inertia } from "@inertiajs/inertia";
import { defineComponent, reactive, ref, toRefs, watch } from "vue";

export default defineComponent({
  props: {
    open: {
      type: Boolean,
      required: true,
    },
  },
  setup(props, { emit }) {
    //   model
    const { open } = toRefs(props);
    const openDialog = ref(false);
    watch(open, (value, prevValue) => {
      openDialog.value = value;
      console.log(value);
    });
    // form

    const form = reactive({
      address: null,
      lat: null,
      long: null,
    });
    const errors = reactive({
      address: null,
      lat: null,
      long: null,
    });
    const submitForm = () => {
      Inertia.post(route("admin.areas.store"), form, {
        onError: (err) => {
          errors.address = err.address;
          errors.lat = err.lat;
          errors.long = err.long;
        },
        onSuccess: () => handleClose(),
      });
    };

    const handleClose = () => {
      emit("close");
      openDialog.value = false;
      errors.address = null;
      errors.lat = null;
      errors.long = null;
      form.address = null;
      form.lat = null;
      form.long = null;
    };
    return {
      openDialog,
      handleClose,
      submitForm,
      form,
      errors,
    };
  },
});
</script>
